import { Overlay } from '@angular/cdk/overlay';
import { ElementRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { ControlValueAccessor, FormControl } from '@angular/forms';
import { CursorPosition } from '../interfaces/cursor-position';
import { MentionConfig } from '../interfaces/mention-config';
import { MentionsResult } from '../interfaces/mentions-result';
import { MentionsSearchTerm } from '../interfaces/mentions-search-term';
import { NgSimpleMarkdownMentionDirective } from '../mentions/ng-simple-markdown-mention.directive';
export declare class NgSimpleMarkdownEditorComponent implements OnInit, OnDestroy, ControlValueAccessor {
    private overlay;
    editingContainerElement: ElementRef<HTMLDivElement>;
    shadowCursorElement: ElementRef<HTMLSpanElement>;
    shadowEditorElement: ElementRef<HTMLPreElement>;
    textareaElement: ElementRef<HTMLTextAreaElement>;
    mentionDirective: NgSimpleMarkdownMentionDirective;
    height: string;
    historySteps: number;
    placeholder: string;
    resize: boolean;
    files: EventEmitter<File[]>;
    mentionConfigs: MentionConfig<any>[];
    mentionSearchTerm: EventEmitter<MentionsSearchTerm>;
    isDisabled: boolean;
    isFullscreen: boolean;
    isWriteMode: boolean;
    cursorPosition: CursorPosition;
    screenSizeBreakpoint: number;
    markdown: FormControl;
    shadowContentUpper: string;
    shadowContentLower: string;
    private resizeOffset;
    private resizeStart;
    private resizeScrollStart;
    private isPerformingUndoRedo;
    private undoStack;
    private redoStack;
    private fullScreenOverlayRef;
    private fullScreenComponentRef;
    private fullScreenControlSubscription;
    private fnOnChange;
    private fnOnTouched;
    private controlSubscription;
    constructor(overlay: Overlay);
    keyboardEvent(event: KeyboardEvent): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    get isMobile(): boolean;
    get editorHeight(): string;
    get isInFullscreen(): boolean;
    get isOpenedMentionMenu(): boolean;
    writeValue(markdown: string): void;
    registerOnChange(fn: (value: string) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    onDrop(event: DragEvent): void;
    onPaste(event: ClipboardEvent): void;
    onInput(): void;
    onResizeStart(event: MouseEvent): void;
    onResizing(event: MouseEvent): void;
    onResizeEnd(): void;
    onEditorScroll(event: Event): void;
    updateCursor(): void;
    fullscreen(): void;
    onSearchResult(result: MentionsResult): void;
    onSearchTerm(term: MentionsSearchTerm): void;
    insertLink(): void;
    insertPhoto(): void;
    bold(): void;
    italic(): void;
    quote(): void;
    code(): void;
    bulletedList(): void;
    numberedList(): void;
    taskList(): void;
    insertContent(content: string, skipBackwardLength?: number): number;
    private saveUndo;
    private undo;
    private redo;
}
